Hi!

This is Mutt version 0.55 ported to MiNT.  Please note that Mutt is a 
somewhat new mailer, parts of it are still alpha- resp. beta code.  Of 
course this applies also to the MiNT version.  So please be careful and 
use this program at your own risk!

If you ever want to ask me (Guido Flohr <gufl0000@stud.uni-sb.de>) if you 
have problems with Mutt make sure that you have read both this file, the 
files BUGS, README, TODO and the documentation in the doc subdirectory!


How to install Mutt?
====================

Copy the executable program to /usr/local/bin or somewhere else in your 
$PATH.  Copy the file Muttrc to /usr/local/share/Muttrc and edit it to 
your own needs.  See the file sample.muttrc for an example.  The 
manual page mutt.1 should go into /usr/local/man/man1.  That's all!


Extended installation needs
===========================

	PGP

Mutt expects pgp to reside in /usr/local/bin/pgp.  Copy pgp there or at 
least create a symbolic link.  If you don't have pgp you might get 
problems with pgp-signed mails (and of course with pgp-encoded mails).  
Mutt automatically calls pgp if it finds out that a particular mail is 
conform to the PGP extensions of MIME.  Thus, if a mail was pgp-signed 
or pgp-encoded Mutt will call pgp in vain.


	Metamail

Mutt has built-in MIME support for several MIME-types.  However, if you 
want to receive audio-, video-, image- or whatever kind of data, you 
should have a working version of metamail installed.  You should be able 
to find metamail at the location where you have picked up Mutt.


	Personal Muttrc files

Mutt will look up its configuration not only in /usr/local/share/Muttrc 
but also in the file .muttrc (note that this file has a lowercase `m') in 
your home directory.  This is the right place to set options for Mutt that 
shouldn't apply system-wide (for instance personal aliases or the 
information for getting mail from your POP3 mailbox).

	POP3

Pop3 (Post Office Protocol version 3) is a protocol that allows 
manipulation of a remote mailbox. The typical internet user has her 
mailbox on a server that is contacted on a regular basis via a PPP or SLIP 
IP-connection over the serial line.  With pop3 you can transfer mails from 
the server of your provider into your mailbox at home.  If your internet 
provider supports pop3 (most of them do) put the following lines into your 
personal .muttrc in your home directory:

# Fill in the address of your mailbox server instead of 
# ``my.internet.provider.com''.
set pophost=my.internet.provider.com
# Your login on the remote machine isn't actually billyboy, is it?
set popuser=billyboy
# Your password on the mailbox server.
set poppass=windoze95
# If you are a coward comment this line out.  If you don't comment it out
# Mutt will delete all mails on the mailbox server after they have been 
# successfully transmitted to your home mailbox.
set popdelete

Note that the pop3 support is still experimental.  It works perfectly 
alright on my machine but it might not on yours.  So be careful.

Just in case:  Pop3 _doesn't_ allow to send spooled mail to your server, 
it's intended for reception only!  See the section "How to spool 
outgoing mail" below for information on spooling your outgoing mail with 
smail.


	Color support

Mutt can be colored if your terminal emulator supports color.  Currently 
this is only the case for the TOSWIN program.  If you run Mutt from within 
TOSWIN you should do the following:

	1.  Check out if you already have a working terminfo database:  
	    Just look for the directories /usr/local/lib/terminfo or 
	    /usr/lib/terminfo or ~/.terminfo/t/tw52 where the tilde (~) 
	    should be replaced by your home directory.

	2.  If you have found a terminfo database try to type

		"tput setaf 1"

	    into your shell.  The foreground color should change to red.  
	    If you don't like red "tput setaf 0" will change it back to 
	    black.

	    If this test didn't work check out if your $TERM envariable is 
	    set to tw52.

		"echo $TERM"

	    This should produce "tw52".

	3.  If step 2 was successful (or if you don't have a color 
	    monitor) you don't have to do anything.  However if you have 
	    TOSWIN and a color monitor the following shell commands will 
	    do:

	    	$ cd $HOME
		$ mkdir .terminfo
		$ mkdir .terminfo/t

	    If you have put the Mutt files (e.g. the one you just read) 
	    into /usr/local/src/mutt-0.55:

	    	$ cp tw52 $HOME/.terminfo/t

Note that Mutt uses ncurses (with terminfo) instead of the old curses 
(with the termcap mechanism).  Thus, if you like it or not,  even if you 
don't have a terminfo database and you don't want to use color Mutt will 
create the file ~/.terminfo/t/tw52 the first time it is called.  (If your 
$TERM is set to "vt52" it will create ~/.terminfo/v/vt52 instead).


Known bugs
==========

See the file BUGS for general known bugs.  The MiNT version has some more:

First the PGP support is far from being stable.  If you sign/encrypt a 
mail it sometimes hangs up the system.  And you absolutely need a MiNT 
version with non-blocking fork, i. e. version >= 1.12.5!!!  If you have an 
older version Mutt will wait forever when you sign a mail.  If you 
want to sign or encrypt a mail lease safe a copy of it before leaving the 
editor.

Mutt seems to have problems with large mailboxes.  At least on my machine 
it sometimes messes them up completely.  Make regular backups!


How to spool mails
==================

This doesn't actually belong to Mutt.  Yet there seems to be need for this 
information in the Atari world.  So why not here?

Mutt is a so-called MUA, i. e. a mail user agent.  This means that Mutt 
only administrates your mailboxes.  With the help of the POP3 protocol it 
can also receive mails from remote servers.  But for sending mail a MTA 
(yes, a mail transport agent) is needed.

The standard MTA is called sendmail and is expected to reside in the 
directory /usr/lib.  However sendmail is a huge monster and actually a 
little oversized for a stand-alone machine like yours.  That's why smail 
is preferred on most Atari machines.  It should be already installed on 
your system if you have the KGMD (Knarf's German MiNT Distribution - now 
avaiable in English, too).

Because most MUAs (including Mutt) expect a program /usr/lib/sendmail, 
smail is installed as /usr/lib/sendmail, too.  Actually this is a symbolic 
link to /usr/bin/smail or wherever you have installed it.

O.K., back to the subject:  I can't explain you how to spool mail with 
sendmail because I don't use it.  With smail it's quite easily done.

First find out where smail's config-file lies:

	$ smail -bP config_file
	/etc/smail/config

Maybe your config file lies in another directory than /etc/smail.  Now you 
have to edit the config file.  Note that you can cut and paste the 
following section.  It makes a valid smail config file but please read the 
comments (i. e. everything after the "#"s):

----- Cut /etc/smail/config -----------
# First of all we have to instruct smail not to send mails immediately but 
# to spool them in /var/spool/smail/input.  Note that the mails in this 
# directory are owned by the superuser and can't be read/written by 
# anybody else.
delivery_mode = queued

# The next line specifies how to compose the "From:" header field.  
# Imagine that there are to real users on your system, Hattie Carroll and 
# Hollis Brown.  Hattie should have the login name "hattie", Hollis is 
# called "hollis".  Imagine that the hostname of your computer is 
# "pepper"
#
# The file /etc/passwd should contain two lines like:
#
# hattie:enTmmkxA/q8ns:201:0:Hattie Carroll:/home/hattie:/bin/tcsh
# hollis:qxJkcUo8dfXzq:202:0:Hollis Brown:/home/hollis:/bin/bash
#
# Hattie's e-mail address is Hattie_Carroll@maryland.com,  Hollis is only 
# a number:  hb745637@cabin.outside.com.
#
# By default smail will put their local addresses into the "From:" header 
# field thus preventing anybody to reply to their mails because 
# "hattie@pepper" is not a valid e-mail address.
#
# Now the following will instruct smail to put the right addresses into 
# the "From:" field:

from_field = "From: \
${if eq{user}{hattie}: Hattie_Carroll@maryland.com}\
${if eq{user}{hollis}: hb745637@cabin.outside.com}\
${if def:sender_name: ($sender_name)}"

# In plain english this means:
# First put the word "From" followed by a colon and a space into the 
# header line.  Then check if the user that has composed the mail has the 
# login "hattie".  If so print "Hattie_Carroll@maryland.com" into that 
# line.  If the user was "hollis" put his address into the header.  Than 
# check the file /etc/passwd if you find the sender's real name.  If you 
# find it place it in brackets after the address.
#
# You can see that you can split long lines with a backslash at the end of 
# the line.  But please make sure that there are no other characters 
# (especially spaces) after the backslash.

# Every internet mail needs a worldwide identification.  Actually it 
# should be composed of some random number (that identifies it uniquely on 
# your local system) followed by an at-sign (the "@") and your hostname.
# But you probably don't have a registered internet domain.  So you have 
# to fake a little bit:
message_id_field = "Message-Id: <$message_id@poorly_configured_pepperMiNT_site>"
# Note that the string "$message_id" will be expanded to a unique 
# identification.

# Maybe you don't need the smart path configuration.  If you specify a 
# smart path smail will not try to establish a connection to the 
# recipient's server but will deliver mails always via the mail server 
# specified as smart path.  This is usually faster than contacting the 
# recipient's servers one by one.
#
# On my personal account it is even necessary.  My provider has a 
# firewall, i. e. I can only access a subset of hosts.  Connections to 
# other hosts can only be performed via a WWW-proxy-server.  So I always 
# have to contact a host that belongs to the local area network of my 
# provider.
#
# We choose maryland.com, Hattie's mail server for delivery.  Note that 
# Hollis mails will also send via this server but it shouldn't cause any 
# problems.
smart_path = maryland.com

# This can be left unchanged.  It simply says to use the "Simple Mail 
# Transfer Protocol - smtp" as specified in RFC821.
smart_transport = smtp

# Just for fun.  Have a look at the created header to see what it does.
visible_domains = .mint.de

----- Cut -----------

Next you have to create the file /etc/smail/routers.  See the comments 
from the author of smail.  Don't worry if you don't understand it.  The 
file doesn't need any editing.  You actually don't need it at all if you 
don't have a smart path in your config file.

----- Cut /etc/smail/routers ------------
# smart_host - a partically specified smarthost director
#
# If the config file attribute smart_path is defined as a path from the
# local host to a remote host, then hostnames not matched otherwise will
# be sent off to the stated remote host.  The config file attribute
# smart_transport can be used to specify a different transport.
#
# If the smart_path attribute is not defined, this router is ignored.
smart_host:
	driver = smarthost,		# special-case driver
	transport = smtp;		# by default deliver over SMTP
------ Cut ----------

Well, that's all.  Now if you want to send mails,  set up the PPP- or SLIP-
connection to your provider and then simply type "runq" into your shell.  
The program "runq" is actually a symbolic link to smail again.  It will 
cause smail to contact the mail server and deliver all spooled mails.  
Note that "runq" deliver mails in the background, i. e. it will return 
immediately.

To see what mails are pending for delivery (or to see if "runq" has 
already delivered all mails) type "mailq" or have a look into 
/var/spool/smail/input (as superuser only).  The "mailq" command (another 
of smail's names) can be performed at any time.  You don't need an IP-
connection for that.

Important:  All instances of smail (sendmail, mailq, runq, ...) will crash 
with a bus error if they are run from bash!  Use the tcsh instead.


How to recompile Mutt?
======================

The programmers among you may be interested in some hints how to recompile 
Mutt yourself (if you don't feel like compiling Mutt yourself, you might 
just can safely skip the rest of this file and start reading Mutt's 
documentation in the directory doc). First of all (and this doesn't apply 
to the Atari/MiNT only): Never configure Mutt with DSN support if you have 
smail instead of sendmail.  The options that Mutt passes to smail for 
sending will be misunderstood by smail.  Smail assumes that you want to 
debug your mail environment and will just check whether the mail could be 
actually delivered and then it will finally send it to /dev/null instead 
of the addressee.  So never run configure with the --enable-dsn option!!!  
It works only with the original sendmail.

Next, you absolutely need ncurses, the new terminfo based curses library, 
to compile Mutt.  Unfortunately at the time that I write this 
(February 97) there is no known port of ncurses to the Atari.  I've 
compiled it myself but especially some of the programs that come along 
with ncurses are still a little buggy.  But there is somebody, probably 
more competent that I am, working on a bugfree port of ncurses.  So just 
wait a little time.

I've included all source files that I had to change here.  Simply replace 
the original files of the Mutt distribution by mine and it should compile 
right away.  BTW, if you are good at fork(), pipe() and so on pray have a 
look at filter.c.  What I've done there is really embarassing yet it was 
the only way I found to make Mutt's pipes work.  Fix it please.

Another one is snprintf.c.  My version of gcc (2.7.2) has problems with 
floats.  Actually the software floating point support is missing in 
MiNTLib.  I simply commented out all of the floating point 
support in snprintf().  I think Mutt doesn't need it.  Yet, this should be 
fixed.

One word to system.c:  Forget about the version of system() that comes 
with MiNTLib PL46.  It doesn't work with Mutt.  A posix conform system() 
should always call /bin/sh to execute the command specified with system(). 
The MiNTLib version tries to parse the command line itself and then 
execute the command via exec().  But as soon as you want to benefit of 
some goodies of the POSIX shell in your system() calls the MiNTLib version 
doesn't work.  To make my version of system() work (my version is actually 
a mixture of the GNU libc 1.97 and MiNTLib) you also have to change a 
#define in wait.c and waitpid.c.  I've included these files from MiNTLib 
with the necessary define.

I hope you will find everything you need.  If you find anything missing 
feel free to contact me but please read the included docs first.  My 
address:

	Guido Flohr
	gufl0000@stud.uni-sb.de
	http://stud.uni-sb.de/~gufl0000

And now have fun with Mutt!
